// ReSharper disable all
using System;
using System.Text.RegularExpressions;
using System.Globalization;
using NUnit.Framework;
using static Demo7.Taulukot;
using Demo7;

namespace TestDemo7
{
	[TestFixture]
	[DefaultFloatingPointTolerance(0.000001)]
	public  class TestTaulukot
	{
		[Test]
		public  void TestErotaDouble32()
		{
			Assert.AreEqual( 0.0, ErotaDouble("") , 0.000001, "in method ErotaDouble, line 33");
			Assert.AreEqual( 2.0, ErotaDouble("",2) , 0.000001, "in method ErotaDouble, line 34");
			Assert.AreEqual( 2.3, ErotaDouble(" 2.3 ") , 0.000001, "in method ErotaDouble, line 35");
			Assert.AreEqual( 5, ErotaDouble("5 3") , 0.000001, "in method ErotaDouble, line 36");
			Assert.AreEqual( 5, ErotaDouble("5k3") , 0.000001, "in method ErotaDouble, line 37");
			Assert.AreEqual( 5000, ErotaDouble("5e3") , 0.000001, "in method ErotaDouble, line 38");
			Assert.AreEqual( 0.005, ErotaDouble("5E-3") , 0.000001, "in method ErotaDouble, line 39");
			Assert.AreEqual( 0.0, ErotaDouble("k") , 0.000001, "in method ErotaDouble, line 40");
			Assert.AreEqual( 1.0, ErotaDouble("k",1.0) , 0.000001, "in method ErotaDouble, line 41");
			Assert.AreEqual( 0.0, ErotaDouble("2..3") , 0.000001, "in method ErotaDouble, line 42");
		}
		[Test]
		public  void TestErota65()
		{
			Assert.AreEqual( 0.0, Erota("",0.0) , 0.000001, "in method Erota, line 66");
			Assert.AreEqual( 2.3, Erota(" 2.3 ",0.0) , 0.000001, "in method Erota, line 67");
			Assert.AreEqual( 5, Erota("5 3",0.0) , 0.000001, "in method Erota, line 68");
			Assert.AreEqual( 0.0, Erota("k",0.0) , 0.000001, "in method Erota, line 69");
			Assert.AreEqual( 1.0, Erota("k",1.0) , 0.000001, "in method Erota, line 70");
			Assert.AreEqual( 0.0, Erota("2..3",0.0) , 0.000001, "in method Erota, line 71");
		}
	}
}

