using System;
using System.Collections.Generic;

namespace Demo7
{
    /// @author  Vesa Lappalainen
    /// @author Enni Stylman
    /// @version 2.11.2019
    /// <summary>
    /// Käsitellään pistejoukkoja
    /// </summary>
    public class Lampotilat
    {
        /// <summary>
        /// Alustetaan pistetaulukko ja kysellään käyttäjältä pisteitä ja tulostetaan
        /// aina sitä lähimmän pisteen koordinaatit.
        /// Ohjelma loppuu kun käyttäjä vastaa pelkän return.
        /// </summary>
        public static void Main()
        {


            List<double> lampotilat = new List<double>();
            String syote = KysyLampotilat(); //kysytään käyttäjältä syötteenä pisteitä
            lampotilat = PilkoSyote(syote, lampotilat); //pilkotaan käyttäjän antama syöte listaan

            char erotin = '|';
            TulostaLampotilat(erotin, lampotilat);

            TulostaTietoja(lampotilat);
        }


        // BYCODEBEGIN


        /// <summary>
        /// Kysy käyttäjältä 12 luvun lista kuukausien keskilämpötiloista (double).
        /// </summary>
        /// <returns></returns>
        public static String KysyLampotilat()
        {
            //TÄYDENNÄ
            return "";
        }


        /// <summary>
        /// Pilko käyttäjän antama syöte ja sijoita
        /// saadut luvut lampotilat-listaan, joka on
        /// luokan attribuuttina.
        /// </summary>
        /// <param name="merkkijono"></param>
        /// <param name="lista">Lista, johon kuukausien keskilämpötilat syötetään</param>
        public static List<double> PilkoSyote(String merkkijono, List<double> lista)
        {
            //TÄYDENNÄ
            return null;
        }


        /// <summary>
        /// Laadi annetuille lämpötiloille jokin sopiva luokittelu
        /// ja tulosta luokitteluun sopivia tietoja kuukausien keskilämpötiloista
        /// konsoliin. 
        /// </summary>
        /// <param name="lista">Lista kuukausien keskilämpötiloista</param>
        public static void TulostaTietoja(List<double> lista)
        {
            //TÄYDENNÄ
            //Muista sopivat apumuuttujat
        }

        /// <summary>
        /// Tulostetaan lämpötoöat muodossa -9.0 | -8.6 | -5.4 | 0.0 | 8.1 | 13.2 | 15.1 | 16.8 | 14.3 | 3.3 | -5.2 | -8.4
        /// </summary>
        /// <param name="erotin">erotinmerkki, joka erottaa tulostuksessa luvut toisistaan.</param>
        /// <param name="lista">lista kuukausien keskilämpötiloista</param>
        public static void TulostaLampotilat(char erotin, List<double> lista)
        {
            // TODO: 
            // Tulosta kaikki listan lämpötilat yhdelle riville.
            // Erota lämpötilat toisistaan erotin merkillä.
        }

        // BYCODEEND
    }
}

namespace MinJypeli
{
    /// <summary>
    /// Satunnaisgeneraattori. Luo satunnaisia arvoja, mm. lukuja, vektoreita sekä kulmia.
    /// </summary>
    public static class RandomGen
    {
        private static readonly Random rand = new Random();

        /// <summary>
        /// Palauttaa satunnaisen liukuluvun parametrien <code>min</code> ja <code>max</code> väliltä.
        /// </summary>
        /// <param name="min">Pienin arvo jonka luku voi saada</param>
        /// <param name="max">Suurin arvo jonka luku voi saada</param>
        /// <returns>Satunnainen reaaliluku</returns>
        public static double NextDouble(double min, double max)
        {
            return min + rand.NextDouble() * (max - min);
        }


        /// <summary>
        /// Palauttaa satunnaisen vektorin.
        /// </summary>
        /// <param name="minX">Pienin sallittu X-koordinaatti</param>
        /// <param name="minY">Pienin sallittu Y-koordinaatti</param>
        /// <param name="maxX">Suurin sallittu X-koordinaatti</param>
        /// <param name="maxY">Suurin sallittu Y-koordinaatti</param>
        /// <returns>Satunnainen vektori</returns>
        public static Vector NextVector(double minX, double minY, double maxX, double maxY)
        {
            return new Vector(NextDouble(minX, maxX), NextDouble(minY, maxY));
        }
    }

    public readonly struct Vector
    {
        /// <summary>
        /// Nollavektori.
        /// </summary>
        public static readonly Vector Zero = new Vector(0.0, 0.0);


        /// <summary>
        /// Etäisyys kahden pisteen välillä.
        /// </summary>
        public static double Distance(Vector p1, Vector p2)
        {
            double x, y;
            x = p1.X - p2.X;
            y = p1.Y - p2.Y;
            return Math.Sqrt((x * x + y * y));
        }

        public readonly double X;
        public readonly double Y;

        /// <summary>
        /// Vektorin pituus.
        /// </summary>
        public double Magnitude => Math.Sqrt(MagnitudeSquared);

        /// <summary>
        /// Vektorin pituuden neliö.
        /// </summary>
        public double MagnitudeSquared => X * X + Y * Y;

        /// <summary>
        /// Luo uuden vektorin komponenteista.
        /// </summary>
        /// <param name="X">X-komponentti</param>
        /// <param name="Y">Y-komponentti</param>
        public Vector(double X, double Y)
        {
            this.X = X;
            this.Y = Y;
        }


        /// <summary>
        /// Vektori merkkijonona, esim (2.3,4.1)
        /// </summary>
        /// <returns>lukupari merkkijonona</returns>
        public override string ToString()
        {
            return $"({X:0.0},{Y:0.0})";
        }


        public static Vector Parse(string vectorStr)
        {
            if (vectorStr == null || vectorStr.Trim() == "") return new Vector(0, 0);

            string s = vectorStr.Replace("(", "").Replace(")", "").Replace(",", " ").Replace("  ", " ").Trim();
            string[] splitStr = s.Split(' ');

            if (splitStr.Length != 2)
                throw new FormatException("Not a vector string: " + vectorStr);

            double x = double.Parse(splitStr[0]);
            double y = double.Parse(splitStr[1]);

            return new Vector(x, y);
        }
    }
}

